#
#
# $Id: libdkim2.spec.in,v 1.6 2023-05-20 12:11:40+05:30 Cprogrammer Exp mbhangui $
%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif

%if %{defined nodebug}
%global debug_package      %{nil}
%endif

%global _prefix            /usr
%global mandir             /usr/share/man
%global _pkg_config_path   /usr/%{_lib}/pkgconfig

%global _verbose           0

%if %build_on_obs == 1
%global packager           Manvendra Bhangui <Manvendra Bhangui <libdkim@indimail.org>>
%endif

%if 0%{?suse_version}
%global dist suse
%global disttag suse
%endif

%if 0%{?fedora_version}
%global dist %{?dist}
%global disttag fedora
%endif

Summary: DKIM Library for indimail-mta
Name: libdkim2
Version: 1.0
Release: 1.1%{?dist}

%if %build_on_obs == 1
License: Apache-2.0
%else
License: ASL 2.0
%endif
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: System/Libraries
%endif
Source0: http://downloads.sourceforge.net/indimail/libdkim2-%{version}.tar.gz
Source1: http://downloads.sourceforge.net/indimail/libdkim2-rpmlintrc

URL: https://github.com/indimail/indimail-mta
#AutoReqProv: No
Conflicts: libdkim
BuildRequires: gcc gcc-c++ make autoconf automake libtool pkgconfig
BuildRequires: findutils diffutils gzip coreutils
BuildRequires: glibc glibc-devel binutils
BuildRequires: openssl-devel

##################################### OBS ####################################
%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks
#!BuildIgnore: post-build-checks
%endif
%endif
##############################################################################
AutoReqProv: Yes
Provides: dkim-libs = %{version}
Provides: dkim-libs%{?_isa} = %{version}
Requires: coreutils glibc openssl findutils pkgconfig

%description
DomainKeys Identified Mail (DKIM) defines a domain-level authentication
framework for email using public-key cryptography and key server technology
to permit verification of the source and contents of messages by either
Mail Transport Agents (MTAs) or Mail User Agents (MUAs).

libdkim2 is a library, developed by Alt-N Technologies, that allows
incorporating DKIM into an existing MTA or other application. It provides
full support for signing, verifying, and SSP. See the changelogs for
information on compliance with specifications.

This package contains the development files needed to compile and link
programs with libdkim2.

%package devel
Summary: Development header files and static library for libdkim2
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: Development/Tools/Other
%endif
Requires: libdkim2 = %{version}

%description devel
This package contains the development header files and libraries
necessary to applications that incorporates DKIM signing, DKIM verification
or both.

%prep
%setup -q -n libdkim2-%{version}

%build
%configure --prefix=%{_prefix} --mandir=%{mandir}

%install
%if 0%{?build_cflags:1}
  CFLAGS="%{build_cflags}"
%else
  CFLAGS="%{optflags}"
%endif
%if 0%{?build_cxxflags:1}
  CXXFLAGS="%{build_cxxflags}"
%else
  CXXFLAGS="%{optflags}"
%endif
%if 0%{?build_ldflags:1}
  LDFLAGS="%{build_ldflags} -pie"
%endif
%if %{undefined centos_version} && %{undefined rhel_version}
  CFLAGS="$CFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
  CXXFLAGS="$CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
%else
%if %{defined centos_version} && 0%{?centos_version} > 700
  CFLAGS="$CFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
  CXXFLAGS="$CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
%endif
%if %{defined rhel_version} && 0%{?rhel_version} > 700
  CFLAGS="$CFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
  CXXFLAGS="$CXXFLAGS -Wno-delete-non-virtual-dtor -Wno-reorder -ffat-lto-objects"
%endif
%endif
%{__make} -s %{?_smp_mflags} CC="%{__cc}" CFLAGS="$CFLAGS" CXXFLAGS="$CXXFLAGS" LDFLAGS="$LDFLAGS"
%if %{defined nodebug}
  %{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install-strip
%else
  %{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install
%endif
for i in %{name} %{name}-devel
do
  %{__mkdir_p} %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 COPYING %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 yahoo-patent-license-1.2.txt %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 AUTHORS %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 README %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 doc/ChangeLog %{buildroot}%{_prefix}/share/doc/$i
done
%{__rm} -f %{buildroot}%{_libdir}/libdkim2.la

%files
%defattr(-, root, root,-)
%{_libdir}/libdkim2.so.1
%{_libdir}/libdkim2.so.1.0.0
%doc %attr(644,root,root)               %{mandir}/man8/*

%attr(755,root,root)                    %{_prefix}/bin/dkim

%if %build_on_obs == 0
%license %attr(0644,root,root)          %{_prefix}/share/doc/%{name}/COPYING
%license %attr(0644,root,root)          %{_prefix}/share/doc/%{name}/yahoo-patent-license-1.2.txt
%else
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/COPYING
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/yahoo-patent-license-1.2.txt
%endif
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/AUTHORS
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/README
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/ChangeLog

%files devel
%dir %attr(755,root,root)               %{_prefix}/include/dkim

%attr(644,root,root)                    %{_prefix}/include/dkim/dkim.h
%attr(644,root,root)                    %{_prefix}/include/dkim/macros.h
%{_libdir}/libdkim2.so
%{_libdir}/libdkim2.a
%{_pkg_config_path}/libdkim2.pc

%if %build_on_obs == 0
%license %attr(0644,root,root)          %{_prefix}/share/doc/%{name}-devel/COPYING
%license %attr(0644,root,root)          %{_prefix}/share/doc/%{name}-devel/yahoo-patent-license-1.2.txt
%else
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/COPYING
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/yahoo-patent-license-1.2.txt
%endif
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/AUTHORS
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/README
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/ChangeLog

%post
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
if [ "$argv1" -eq 2 ] ; then # upgrade
  # we are doing upgrade
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    /sbin/ldconfig
  fi
fi

%postun
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  /sbin/ldconfig
fi

%changelog
* Sun Jun 16 2024 10:15:56 +0000 Manvendra Bhangui <libdkim@indimail.org> 1.0-1.1%{?dist}
Release 1.7-1.1 Start 01/02/2023 End 09/01/2024
- new function DKIMSignReplaceHash to alter current Hash method
- dkim.cpp: Generate dkim-signature for each -s option passed on command
  line
- dkimverify.cpp: return actual signature error in ProcessHeaders instead of
  "no valid sigs"
- dkim.cpp: added dkim_error_str function to return DKIM error
- dkim.h: added DKIM_EVP_SIGN_FAILURE, DKIM_EVP_DIGEST_FAILURE
  definitions for EVP signing and digest failures
- dkimsign.cpp: check for EVP sign and digest failures
- dkimsign.cpp: fixed a= tag to "ed25519-sha256"
- dkimverify.cpp: fixed verification of ed25519 signature without ASN.1
  structure
- dkimverify.cpp: fixed multi-signature verfication (rsa+ed25519)
- dkim.cpp: fixed usage strings
- dkimverify.cpp: Fixed SIGSEGV with missing k= tag in DKIM txt record
- dkimverify.cpp: use error routine only for EVP functions failure
- dkimsign.cpp: fixed compiler warning of use of uninitialized variable
- use Replaces, Conflicts in spec,control
- dkim.cpp: Added -X option to have colon seperated list of headers to be
  excluded from DKIM signing.
- dkim.cpp: Added env variable EXCLUDE_DKIMSIGN to exclude headers from
  DKIM signing
- dkim.cpp, dkimsigin.cpp: Exclude Arc-Authentication-Results from DKIM
  signing
- dkim.h: Added error code DKIM_BAD_IDENTITY for invalid identity domain
- dkimverify.cpp, dkim.cpp: use new error code DKIM_BAD_IDENTITY for
  invalid identity domain (i= tag)
- dkimsign.cpp: Use strrchr instead of strchr for extracting domain
- dkim.h: re-arranged DKIM error codes.
- fix discarded-qualifier compiler warnings
